
#include"p30f2011.h"
#include "LCD.h"
#include "main.h"


void IntToChar(int number, char *chr)	//Convert integer to charater array
{
	unsigned int Divisor = 10000;
	if(number == 0)
	{
		*chr = '0';
		chr++;
		*chr = 0;
		return;
	}
	if((number & 0b1000000000000000) == 0b1000000000000000)
	{
		number = number * -1;
		*chr = '-';
		chr++;
	}

	*chr = '0';
	while(*chr == '0')
	{
		*chr = number/Divisor + 48;
		number = number%Divisor;
		Divisor = Divisor/10;
	}
	if(Divisor == 0)
	{
		chr++;
		*chr = 0;
	}
	while(*chr != 0)
	{
		chr++;
		*chr = number/Divisor + 48;
		number = number%Divisor;
		if(Divisor == 1)
		{
			chr++;
			*chr = 0;
		}
		Divisor = Divisor/10;
	}
	
}


void LCDInit()
{
	__delay_ms(200)
    RS = 0;               
    R_W = 0;
 	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0011;
    E = 1;
	__delay_ms(10);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0011;
    E = 1;
	__delay_ms(10);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0011;
    E = 1;
	__delay_ms(10);	
	E = 0;	
 	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0010;
    E = 1;
	__delay_ms(10);	
	E = 0;
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0000;
    E = 1;
	__delay_ms(10);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0001;
    E = 1;
	__delay_ms(10);	
	E = 0;
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0010;
    E = 1;
	__delay_ms(10);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b1000;
    E = 1;
	__delay_ms(10);	
	E = 0;
  	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b0000;
    E = 1;
	__delay_ms(1);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & 0b1100;
    E = 1;
	__delay_ms(1);	
	E = 0;		
}


void LCDSendCommand(unsigned char Cmd)
{
	RS = 0;
	__delay_us(40);
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & ((Cmd >> 4)| 0b11110000);
    E = 1;
	__delay_us(40);	
	E = 0;	
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & (Cmd | 0b11110000);
    E = 1;
	__delay_us(40);	
	E = 0;
}

void LCDSendString(char *ptr)
{
	RS = 1;
	__delay_us(40);
	while(*ptr != 0)        
	{
			LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & ((*ptr >> 4) | 0b11110000);
			E = 1;
			__delay_us(40);
			E = 0;
			LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & (*ptr | 0b11110000);
			E = 1;
			__delay_us(40);
			E = 0;
			ptr++;   
	}
}



void LCDSendChar(unsigned char *chr)
{
	RS = 1;
	__delay_us(40);
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & ((*chr >> 4)| 0b11110000);
	E = 1;
	__delay_us(40);
	E = 0;
	LCD_DATA_PIN = (LCD_DATA_PIN | LCDMASK) & (*chr | 0b11110000);
	E = 1;
	__delay_us(40);
	E = 0;
}

void LCDSetCGRAM(unsigned char Address, unsigned char *ptr)
{
	LCDSendCommand(CG_RAM_ADDR | Address);
	RS = 1;
	__delay_us(40);
	char i;
	for(i = 0; i < 8; i++)        
	{
			LCD_DATA_PIN = (*ptr >> 4| LCDMASK) & LCD_DATA_PIN;
			E = 1;
			__delay_us(40);
			E = 0;
			LCD_DATA_PIN = (*ptr| LCDMASK) & LCD_DATA_PIN;
			E = 1;
			__delay_us(40);
			E = 0;
			ptr++;   
	}
}
